import React, { useEffect } from "react";
import { Modal, Input, Form } from "antd";

// 审批意见
function AuditModal(props) {
  const { visible, onCancel, onOk, loading } = props;
  const [form] = Form.useForm();
  const formLayout = { labelCol: { span: 4 }, wrapperCol: { span: 14 } };

  const handleOk = async () => {
    let fieldsValue = await form.validateFields();
    onOk(fieldsValue);
  };

  useEffect(() => {
    if (visible) form.resetFields();
  }, [visible]);
  return (
    <Modal
      confirmLoading={loading}
      destroyOnClose
      title="流程"
      open={visible}
      onCancel={onCancel}
      onOk={handleOk}
    >
      <Form {...formLayout} form={form}>
        <Form.Item label="流程名称" name="name">
          <Input />
        </Form.Item>
        <Form.Item label="详情" name="desc">
          <Input.TextArea />
        </Form.Item>
      </Form>
    </Modal>
  );
}

export default AuditModal;
